Skip to main content

Binary Search - Hard Level - Question 3

Binary Search - Hard Level - Question 3


878. Nth Magical Number

A positive integer is magical if it is divisible by either a or b.

Given the three integers n, a, and b, return the nth magical number. Since the answer may be very large, return it modulo 10^9 + 7.


Analysis:

Let us consider some examples first.

Example 1, a = 4, b = 2. If b is dividable by a, then all the numbers which is dividable by a should be dividable by b as well. So the nth magical number should be n*b;

Example 2, a = 3, b = 2.

The multiples of 2 are: 2, 4, 6, 8, 10, 12, ...

The multiple of 3 are: 3, 6, 9, 12, ...

So the overlap is related to the minimum common multiple between a and b, and we need to remove the overlap which is double-counted.

So now, we make some conclusions:

1. the upper bound of the nth magical number should be n*b, where a is the smaller one (or b <= a);

2. there are n*b/a magical numbers smaller than n*b;

3. there are n*b/(minimum common multiple) overlaps.

Thus, the overall count is: n + n*b/a - n*b/(minimum common multiple).

This is monotonically increasing function of n, so we can use binary search to determine the minimum value of n.

One detail to about the boundary: for example, 10 is 7th magical number of 2 and 3. Then how about the 6th? In this case, we need to check whether the minimum value of multiple of a is jus the nth or (n+1)th magical number. If it is the (n+1)th, then we need to use the closest multiple of b.

In the above example, from the binary search, n = 5. So the value is 5*2 = 10. However, there are 7 multiples <= 10. So 10 is the 7th magical number, not the 6th. The 6th magical number is 5*2/3*3 = 9.


See the code below:

class Solution {
public:
    int nthMagicalNumber(int n, int a, int b) {
        if(a<b) return nthMagicalNumber(n, b, a);
        int l = 1, r = n, mod = 1e9 + 7;
        long c = gcd(a, b), d = (long)a*(long)b/c;
        if(c == b) return (long)r*b%mod;
        while(l < r) {
            int mid = l + (r - l) / 2;
            int ct = count(mid, a, b, d);
            if(ct < n) l = mid + 1;
            else r = mid;
        }
        if(count(l, a, b, d) > n) return (long)l*b/a*a%mod;
        return (long)l*b%mod;
    }
private:
    int gcd(int a, int b) {
        if(a < b) return gcd(b, a);
        if(b == 0) return a;
        return gcd(a%b, b);
    }
    int count(int mid, int a, int b, int d) {
        long v = (long)mid * b;
        return mid + v/a - v/d;
    }
};


Upper Layer

Comments

Popular posts from this blog

Graph Question - Hard Level - Question 1

2246. Longest Path With Different Adjacent Characters You are given a tree (i.e. a connected, undirected graph that has no cycles) rooted at node 0 consisting of n nodes numbered from 0 to n - 1. The tree is represented by a 0-indexed array parent of size n, where parent[i] is the parent of node i. Since node 0 is the root, parent[0] == -1. You are also given a string s of length n, where s[i] is the character assigned to node i. Return the length of the longest path in the tree such that no pair of adjacent nodes on the path have the same character assigned to them. Constraints: n == parent.length == s.length 1 <= n <= 10^5 0 <= parent[i] <= n - 1 for all i >= 1 parent[0] == -1 parent represents a valid tree. s consists of only lowercase English letters. Analysis For this question, we need to construct a graph, or more specifically, a n-nary tree. How to construct the graph/tree? What we only know is the parent array. So we need to go through the parent array and constr...

Bit Manipulation - Medium Level

 Leetcode 416 Partition Equal Subset Sum Given a non-empty array nums containing only positive integers, find if the array can be partitioned into two subsets such that the sum of elements in both subsets is equal. Constraints: 1 <= nums.length <= 200 1 <= nums[i] <= 100 Analysis: There are different ways to solve this problem, such as dp with a time complexity of O(N^2). Since N is small to this question, so it is Okay to pass OJ. Besides the small N, the value of each element is also very small. So this gives us some chance to use "space to trad off time". The data structure to be used is bitset. For bitset, each bit can be either 0 or 1. The index of that bit can be used as the corresponding sum. When the bit is 1, means there is a sum with the value of its index. When a new number comes, this number needs to be added to all the previous sums, to form new "previous" sums. Thus for each number, we need to go through all the previous sums, the time co...